import { AngularFireAuth } from '@angular/fire/auth';
import { AngularFirestore } from '@angular/fire/firestore';
import { Observable } from 'rxjs';
import { Router } from '@angular/router';
import { User } from '../interface/user';
import { EnvConfig } from '../interface/env-config';
import { NzMessageService } from 'ng-zorro-antd';
export declare class AuthService {
    private config;
    private afAuth;
    private message;
    private router;
    private afs;
    user$: Observable<User>;
    constructor(config: EnvConfig, afAuth: AngularFireAuth, message: NzMessageService, router: Router, afs: AngularFirestore);
    login(username: any, password: any): void;
    signup(username: any, password: any): void;
    signOut(): Promise<void>;
    private updateUserData;
    canRead(user: User): boolean;
    canEdit(user: User): boolean;
    canDelete(user: User): boolean;
    private checkAuthorization;
}
